#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_IO__TFile__
#define __HROOT_IO__TFile__

#include "HROOT-ioType.h"
#include "HROOTIOTDirectoryFile.h"
#include "HROOTCoreTDirectory.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TFILE_DECL_VIRT 
#define TFILE_DECL_VIRT(Type) \


#undef TFILE_DECL_NONVIRT 
#define TFILE_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTFile ( const char* fname, const char* option, const char* ftitle, int compress )

#undef TFILE_DEF_VIRT
#define TFILE_DEF_VIRT(Type)\


#undef TFILE_DEF_NONVIRT
#define TFILE_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTFile ( const char* fname, const char* option, const char* ftitle, int compress )\
{\
Type * newp = new Type (fname, option, ftitle, compress); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TDIRECTORYFILE_DECL_VIRT(TFile);
TDIRECTORY_DECL_VIRT(TFile);
TNAMED_DECL_VIRT(TFile);
TOBJECT_DECL_VIRT(TFile);
DELETABLE_DECL_VIRT(TFile);


TFILE_DECL_VIRT(TFile);


TFILE_DECL_NONVIRT(TFile);


#endif // __HROOT_IO__TFile__

#ifdef __cplusplus
}
#endif

