{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.IO.TDirectoryFile.Implementation where
import FFICXX.Runtime.Cast
import Data.Word
import Foreign.C
import Foreign.Ptr
import System.IO.Unsafe
import HROOT.IO.TDirectoryFile.RawType
import HROOT.IO.TDirectoryFile.FFI
import HROOT.IO.TDirectoryFile.Interface
import HROOT.IO.TDirectoryFile.Cast
import HROOT.Core.TKey.RawType
import HROOT.Core.TKey.Cast
import HROOT.Core.TKey.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

instance ITDirectoryFile TDirectoryFile

instance ITDirectory TDirectoryFile where
        append = xform2 c_tdirectoryfile_append
        addD = xform2 c_tdirectoryfile_addd
        appendKey = xform1 c_tdirectoryfile_appendkey
        close = xform1 c_tdirectoryfile_close
        get = xform1 c_tdirectoryfile_get
        cd_TDirectory = xform1 c_tdirectoryfile_cd_tdirectory

instance ITNamed TDirectoryFile where
        setName = xform1 c_tdirectoryfile_setname
        setNameTitle = xform2 c_tdirectoryfile_setnametitle
        setTitle = xform1 c_tdirectoryfile_settitle

instance ITObject TDirectoryFile where
        draw = xform1 c_tdirectoryfile_draw
        findObject = xform1 c_tdirectoryfile_findobject
        getName = xform0 c_tdirectoryfile_getname
        isA = xform0 c_tdirectoryfile_isa
        paint = xform1 c_tdirectoryfile_paint
        printObj = xform1 c_tdirectoryfile_printobj
        saveAs = xform2 c_tdirectoryfile_saveas
        write = xform3 c_tdirectoryfile_write

instance IDeletable TDirectoryFile where
        delete = xform0 c_tdirectoryfile_delete
