{-# LANGUAGE FlexibleInstances, FlexibleContexts, TypeFamilies,
  MultiParamTypeClasses, OverlappingInstances, IncoherentInstances
  #-}
module HROOT.IO.TDirectoryFile.Cast where
import Foreign.Ptr
import FFICXX.Runtime.Cast
import System.IO.Unsafe
import HROOT.IO.TDirectoryFile.RawType
import HROOT.IO.TDirectoryFile.Interface

instance (ITDirectoryFile a, FPtr a) => Castable a
         (Ptr RawTDirectoryFile) where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))

instance Castable TDirectoryFile (Ptr RawTDirectoryFile) where
        cast x f = f (castPtr (get_fptr x))
        uncast x f = f (cast_fptr_to_obj (castPtr x))
