{-# LANGUAGE ForeignFunctionInterface #-}
module HROOT.IO.TDirectoryFile.FFI where
import Foreign.C
import Foreign.Ptr
import HROOT.IO.TDirectoryFile.RawType
import HROOT.Core.TObject.RawType
import HROOT.Core.TKey.RawType
import HROOT.Core.TClass.RawType

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_Append"
               c_tdirectoryfile_append ::
               Ptr RawTDirectoryFile -> Ptr RawTObject -> CInt -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_addD" c_tdirectoryfile_addd
               :: Ptr RawTDirectoryFile -> Ptr RawTObject -> CInt -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_AppendKey"
               c_tdirectoryfile_appendkey ::
               Ptr RawTDirectoryFile -> Ptr RawTKey -> IO CInt

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_Close"
               c_tdirectoryfile_close :: Ptr RawTDirectoryFile -> CString -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_Get" c_tdirectoryfile_get
               :: Ptr RawTDirectoryFile -> CString -> IO (Ptr RawTObject)

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_cd_TDirectory"
               c_tdirectoryfile_cd_tdirectory ::
               Ptr RawTDirectoryFile -> CString -> IO CInt

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_SetName"
               c_tdirectoryfile_setname ::
               Ptr RawTDirectoryFile -> CString -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_SetNameTitle"
               c_tdirectoryfile_setnametitle ::
               Ptr RawTDirectoryFile -> CString -> CString -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_SetTitle"
               c_tdirectoryfile_settitle ::
               Ptr RawTDirectoryFile -> CString -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_Draw" c_tdirectoryfile_draw
               :: Ptr RawTDirectoryFile -> CString -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_FindObject"
               c_tdirectoryfile_findobject ::
               Ptr RawTDirectoryFile -> CString -> IO (Ptr RawTObject)

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_GetName"
               c_tdirectoryfile_getname :: Ptr RawTDirectoryFile -> IO CString

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_IsA" c_tdirectoryfile_isa
               :: Ptr RawTDirectoryFile -> IO (Ptr RawTClass)

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_Paint"
               c_tdirectoryfile_paint :: Ptr RawTDirectoryFile -> CString -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_printObj"
               c_tdirectoryfile_printobj ::
               Ptr RawTDirectoryFile -> CString -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_SaveAs"
               c_tdirectoryfile_saveas ::
               Ptr RawTDirectoryFile -> CString -> CString -> IO ()

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_Write"
               c_tdirectoryfile_write ::
               Ptr RawTDirectoryFile -> CString -> CInt -> CInt -> IO CInt

foreign import ccall safe
               "HROOTIOTDirectoryFile.h TDirectoryFile_delete"
               c_tdirectoryfile_delete :: Ptr RawTDirectoryFile -> IO ()
