{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.IO.TDirectoryFile.Interface where
import Data.Word
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.IO.TDirectoryFile.RawType
import HROOT.Core.TDirectory.Interface

class ITDirectory a => ITDirectoryFile a

upcastTDirectoryFile ::
                     forall a . (FPtr a, ITDirectoryFile a) => a -> TDirectoryFile
upcastTDirectoryFile h
  = let fh = get_fptr h
        fh2 :: Ptr RawTDirectoryFile = castPtr fh
      in cast_fptr_to_obj fh2

downcastTDirectoryFile ::
                       forall a . (FPtr a, ITDirectoryFile a) => TDirectoryFile -> a
downcastTDirectoryFile h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
